
/*******************************************************/
/**                                                   **/
/**        bots.h (c) 1996, 97 Emiel Bruijntjes       **/
/**                                                   **/
/**      The botlist + bot-I/O + start of parsing     **/
/**                                                   **/
/*******************************************************/


#ifndef BOTS_H_
#define BOTS_H

#include <stdio.h>

void addbot(char *nick, char *hostname, int port);
void delbot();
void deleteallbots();

int  botlist_findbot(char *nick);
int  botlist_findfirst();
int  botlist_findnext();
int  botlist_findsockptr(int);
int  botlist_length();

char *botlist_nick();
char *botlist_host();
char *botlist_password();
char *botlist_nickuserhost();
char *botlist_version();
int   botlist_port();
int   botlist_protection();
int   botlist_autoconnect();       /* Should bot be linked automatically when it's not part of the botnet? */

int   botlist_allowconnection();   /* allow an incoming connection from this bot? */

void botlist_setaddress(char *host, int port);
void botlist_setprot();
void botlist_resetprot();
void botlist_setnickuserhost(char *nickuserhost);
void botlist_setpassword(char *password);
void botlist_setversion(char *version);
void botlist_setpong();
void botlist_setautoconnect();
void botlist_resetautoconnect();

int  loadbots(FILE *fp, int);
void savebots(FILE *fp);

void botlist_send2all(char *format, ...);
void botlist_send2allexceptcurrent(char *format, ...);
void botlist_send2current(char *format, ...);

int botlist_startconnection();    /* 0 Bot is already connecting
				   * 1 Bot is already connected but has not yet "identified"
				   * 2 Bot is already connected and in bottree
				   * 3 Connection refused
				   * 4 Connecting ...
				   * 5 Connection established
				   */

void botlist_connection_established();
void botlist_connectionlost();
void botlist_parse_input(char *);
void botlist_breakconnection();
void botlist_linkestablished();
void botlist_incominglink(int);

void botlist_check_and_send_pings();

#endif
