
/*******************************************************/
/**                                                   **/
/**      chanuser.h (c) 1996, 97 Emiel Bruijntjes     **/
/**                                                   **/
/**        Database with users active on channel      **/
/**                                                   **/
/*******************************************************/

#ifndef _CHANUSER_H_
#define _CHANUSER_H_

typedef struct {

  struct _ch_user_t *current;
  struct _ch_user_t *first;
  struct _ch_user_t *last;

} chanusers_t;

typedef struct _ch_user_t {

  char *nick;
  char  chanop;
  
  struct _ch_user_t *next;
  struct _ch_user_t *prev;

} ch_user_t;

void  init_chanusers_t(chanusers_t *chusers);  /* initialize chanusers_t, call this function before using the variable */
void empty_chanusers_t(chanusers_t *chusers);  /* remove all the users from the list */

void chanusers_join_channel(chanusers_t *chusers, char *nick);
void chanusers_part_channel(chanusers_t *chusers);

int  chanusers_length(chanusers_t *chusers);

int  chanusers_findnick (chanusers_t *chusers, char *nick);
int  chanusers_findfirst(chanusers_t *chusers);
int  chanusers_findlast (chanusers_t *chusers);
int  chanusers_findnext (chanusers_t *chusers);
int  chanusers_findprev (chanusers_t *chusers);

void chanusers_mark_chanop    (chanusers_t *chusers);
void chanusers_mark_not_chanop(chanusers_t *chusers);

char *chanusers_nick(chanusers_t *chusers);
int   chanusers_ischanop(chanusers_t *chusers);

#endif /* _CHANUSER_H_ */
