	
/********************************************************/
/**                                                    **/
/**      console.c (c) 1996, 97 Emiel Bruijntjes       **/
/**                                                    **/
/**         Handling output to the console(s)          **/
/**                                                    **/
/********************************************************/

#ifdef SUNOS
#include "sunos.h"
#endif


#include <stdarg.h>
#include <stdio.h>


#include "term.h"
#include "config.h"
#include "console.h"
#include "xwin.h"
#include "out_console.h"

static int current_console_mode = CONSOLE_IRC_MODE;

void console_print_mode()   { 

  if (have_terminal) term_print_mode_line();   
  if (nr_X_consoles) X_print_window_title();
  if (nr_out_consoles) sendmode2out_consoles();
}

void console_print_status() { 

  if (have_terminal) term_print_status_line();
  if (nr_X_consoles) X_print_window_title();
  if (nr_out_consoles) sendmode2out_consoles();
}

void console_send2snoopwindow(char *format, ...) {

  char    line[WAYTOBIG_OUT];
  va_list msg;

  if ((have_terminal == 0) && (nr_X_consoles == 0) && (nr_out_consoles == 0)) return;

  if(!format) return;
  va_start(msg, format);
  vsprintf(line, format, msg);

  line[WAYTOBIG_OUT-1] = '\0';         /* make sure it ends with 0 */
  va_end(msg);
 
  if (have_terminal) term_send2window(TERM_SNOOP_WINDOW, line);
  if (nr_X_consoles) X_send2window(X_SNOOP_WINDOW, line);
  if (nr_out_consoles) send2out_consoles_win1(line);
}


void console_send2snoopwindow2(char *format, ...) {      /* Print (---) *** message on upper window */

  char    line[WAYTOBIG_OUT]="(---) *** ";
  va_list msg;

  if ((have_terminal == 0) && (nr_X_consoles == 0) && (nr_out_consoles == 0)) return;

  if(!format) return;
  va_start(msg, format);
  vsprintf(line+10, format, msg);

  line[WAYTOBIG_OUT-1] = '\0';         /* make sure it ends with 0 */
  va_end(msg);
 
  if (have_terminal) term_send2window(TERM_SNOOP_WINDOW, line);
  if (nr_X_consoles) X_send2window(X_SNOOP_WINDOW, line);
  if (nr_out_consoles) send2out_consoles_win1(line);
}


void console_send2ircwindow(char *format, ...) {      /* Print message on IRC window */

  char    line[WAYTOBIG_OUT];
  va_list msg;

  if ((have_terminal == 0) && (nr_X_consoles == 0) && (nr_out_consoles == 0)) return;

  if(!format) return;
  va_start(msg, format);
  vsprintf(line, format, msg);

  line[WAYTOBIG_OUT-1] = '\0';         /* make sure it ends with 0 */
  va_end(msg);
 
  if (have_terminal) term_send2window(TERM_IRC_WINDOW, line);
  if (nr_X_consoles) X_send2window(X_IRC_WINDOW, line);
  if (nr_out_consoles) send2out_consoles_win2(line);
}


void console_send2ircwindow2(char *format, ...) {      /* Print message on IRC window, preceeded by *** */

  char    line[WAYTOBIG_OUT]="*** ";
  va_list msg;

  if ((have_terminal == 0) && (nr_X_consoles == 0) && (nr_out_consoles == 0)) return;

  if(!format) return;
  va_start(msg, format);
  vsprintf(line+4, format, msg);

  line[WAYTOBIG_OUT-1] = '\0';         /* make sure it ends with 0 */
  va_end(msg);

  if (have_terminal) term_send2window(TERM_IRC_WINDOW, line);
  if (nr_X_consoles) X_send2window(X_IRC_WINDOW, line);
  if (nr_out_consoles) send2out_consoles_win2(line);
}


int console_mode() { return current_console_mode; }

void console_setmode(int c) { current_console_mode = c; console_print_mode(); }
