
/*******************************************************/
/**                                                   **/
/**       gencmd.h (c) 1996, 97 Emiel Bruijntjes      **/
/**                                                   **/
/**   General commands. Could be entered by console,  **/
/**             session or via telnet                 **/
/**                                                   **/
/*******************************************************/

/* IRC output functions */

void gen_cmd_msg(char *to, char *message, void function(char *, ...));   /* send privmsg to irc with function FUNCTION */
void gen_cmd_notice(char *to, char *message, void function(char *, ...));   /* send notice to irc with function FUNCTION */
void gen_cmd_me(char *to, char *message, void function(char *, ...));

void gen_cmd_signoff(char *comment);  /* Stop the bot with comment */

/* Other output functions */

int catfile(char *file, void function(char *, ...), char *from);  /* Print file "file" with function "function", replacing
								   * %-variables. "from" is needed for %N. Specify NULL
								   * when "from" is not known. */
/* Database functions */

void gen_cmd_addbot (char *argv[], int argc, void output(char *, ...));
void gen_cmd_botaddr(char *argv[], int argc, void output(char *, ...));
void gen_cmd_botinfo(char *argv[], int argc, void output(char *, ...), int echopass);
void gen_cmd_botlist(char *argv[], int argc, void output(char *, ...));
void gen_cmd_botnuh (char *argv[], int argc, void output(char *, ...));
void gen_cmd_botpass(char *argv[], int argc, void output(char *, ...));
void gen_cmd_botprot(char *argv[], int argc, void output(char *, ...));
void gen_cmd_botac  (char *argv[], int argc, void output(char *, ...));
void gen_cmd_delbot (char *argv[], int argc, void output(char *, ...));
void gen_cmd_link   (char *argv[], int argc, void output(char *, ...), char *from);
void gen_cmd_unlink (char *argv[], int argc, void output(char *, ...), char *from);

void gen_cmd_addchan(char *argv[], int argc, void output(char *, ...), void irc(char *, ...));
void gen_cmd_delchan(char *argv[], int argc, void output(char *, ...), void irc(char *, ...));

void gen_cmd_addserv(char *argv[], int argc, void output(char *, ...));
void gen_cmd_delserv(char *argv[], int argc, void output(char *, ...));
void gen_cmd_server (char *argv[], int argc, void output(char *, ...));

void gen_cmd_allow   (char *argv[], int argc, void output(char *, ...));
void gen_cmd_cmdreq  (char *argv[], int argc, void output(char *, ...));
void gen_cmd_linereq (char *argv[], int argc, void output(char *, ...));
void gen_cmd_partycmd(char *argv[], int argc, void output(char *, ...));
void gen_cmd_protkey (char *argv[], int argc, void output(char *, ...));
void gen_cmd_set     (char *argv[], int argc, void output(char *, ...));

void gen_cmd_hour  (char *argv[], int argc, void output(char *, ...));
void gen_cmd_rehash(char *argv[], int argc, void output(char *, ...));
void gen_cmd_http  (char *argv[], int argc, void output(char *, ...));
void gen_cmd_listen(char *argv[], int argc, void output(char *, ...));

void gen_cmd_info(char *argv[], int argc, void output(char *, ...));
void gen_cmd_time(char *argv[], int argc, void output(char *, ...));
void gen_cmd_cons(char *argv[], int argc, void output(char *, ...));

void gen_cmd_userlist(char *argv[], int argc, void output(char *, ...));
void gen_cmd_top     (char *argv[], int argc, void output(char *, ...));
void gen_cmd_keep    (char *argv[], int argc, void output(char *, ...));
void gen_cmd_unkeep  (char *argv[], int argc, void output(char *, ...));
void gen_cmd_manip   (char *argv[], int argc, void output(char *, ...));

void gen_cmd_maskinfo(char *argv[], int argc, void output(char *, ...), int echopass);
void gen_cmd_stats   (char *argv[], int argc, void output(char *, ...));

void gen_cmd_xwin(char *argv[], int argc, void output(char *, ...));

void gen_cmd_tcl      (char *argv[], int argc, void output(char *, ...));
void gen_cmd_addscript(char *argv[], int argc, void output(char *, ...));
void gen_cmd_delscript(char *argv[], int argc, void output(char *, ...));
void gen_cmd_scripts  (char *argv[], int argc, void output(char *, ...));

