
/*******************************************************/
/**                                                   **/
/**        misc.h (c) 1996, 97 Emiel Bruijntjes       **/
/**                                                   **/
/**              Miscellaneous functions              **/
/**                                                   **/
/*******************************************************/


#ifndef MISC_H_
#define MISC_H_

#include <stdio.h>
#include <time.h>

void putlog(char *file, char *format, ...);

char * repairstring(char *argv[], int argc);
void   split_string(char *string, char *argv[], int *argc);

char * time2string(time_t);

void * xmalloc (size_t);
void * xrealloc (void *, size_t);
/*
void   xfree (void *);
*/
#define xfree(p) if ((p)!=NULL) free(p);

int     freadint(FILE *, int *);
int     fwriteint(FILE *, int);
int     fwritechar(FILE *, char);
int     freadchar(FILE *, char *);
int     freadtime_t(FILE *, time_t *);
int     fwritetime_t(FILE *, time_t);
void    fwritestr2bin(char *, FILE *);
size_t  fgetstrfrombin(char **, FILE *); 
size_t  my_getdelim(char **, FILE *, int);
int     my_feof(FILE *);

int nickonly(char *, char *);
int is_channel(char *string);
int is_user(char *);

/* returnt 1 als user, 0 als server */

char * spaces(int);   /* Returns N spaces */

int getalnaarbin(int);
void maakbanmatch(char *, char *);

char *botonly(char *);

int is_bot(char *);

void hoofdletter(char *);

#define MIN(a, b)    ((a)<(b)?(a):(b))
#define MAX(a, b)    ((a)<(b)?(b):(a))

int hex2dec(char *str, int n);

#endif

