
/*********************************************************/
/**                                                     **/
/**           on.c (c) 1997, Emiel Bruijntjes           **/
/**                                                     **/
/**           database with tcl-on procedures           **/
/**                                                     **/
/*********************************************************/

#define  ON_MSG             1
#define  ON_PUBLIC          2
#define  ON_PUBLIC_NOTICE   3
#define  ON_NOTICE          4
#define  ON_JOIN            5
#define  ON_PART            6
#define  ON_NICK            7
#define  ON_KICK            8
#define  ON_QUIT            9
#define  ON_MODE           10
#define  ON_CONNECT        11
#define  ON_CONSOLE        12
#define  ON_LINK           13
#define  ON_UNLINK         14
#define  ON_CTCP           15
#define  ON_CTCP_REPLY     16
#define  ON_BOTNET         17
#define  ON_OUTSIDE        18
#define  ON_IRC_INPUT      19
#define  ON_IRC_CMD        20
#define  ON_OUTSIDE_CMD    21
#define  ON_TIMER          22

int add_on(int type, int nr, char *mask, char *proc);
int del_on(int type, int nr, char *mask);


int on_msg(char *nickuserhost, char *message);
int on_public(char *channel, char *nickuserhost, char *message);
int on_public_notice(char *channel, char *nickuserhost, char *message);
int on_notice(char *nickuserhost, char *message);
int on_join(char *nickuserhost, char *channel);
int on_part(char *nickuserhost, char *channel);
int on_nick(char *oldnick, char *newnick);
int on_kick(char *from, char *kicked, char *channel, char *comment);
int on_quit(char *nickuserhost, char *comment);
int on_mode(char *from, char *channel, char *mode);
int on_connect(char *from);
int on_console(char *msg);
int on_link(char *parent, char *bot);
int on_unlink(char *bot);
int on_ctcp(char *from, char *command, char *rest);
int on_ctcp_reply(char *from, char *command);
int on_botnet(char *bot, char *message);
int on_outside(char *nick, char *message);
int on_irc_input(char *nick, char *message);
int on_irc_cmd(char *nick, char *message);
int on_outside_cmd(char *nick, char *message);
int on_timer();
