
/*********************************************************/
/**                                                     **/
/**       server.h (c) 1996, 97 Emiel Bruijntjes        **/
/**                                                     **/
/** Server-database + sending mesages to current server **/
/**                                                     **/
/*********************************************************/


#ifndef SERVER_H_
#define SERVER_H_

#include <stdio.h>

void save_servers(FILE *);
int  load_servers(FILE *);

void init_server();            /* Function to be called whenever a server connection succeeds */
void lost_server();            /* Function to be called whenever a server connection is lost */
int  setserver(char *, int);   /* Adds a server to the server-list. returns 0 on failure */
void nextserver();             /* Disconnects from the current server and connects to the next one in the list */
void printservers(void output(char *, ...));    /* Prints the current servers */
int  gotoserver(int);          /* Connects to server number "int" in the server-list */
int  delserver(int);           /* Deletes server number "int" in the server-list */
void server_lost();


void      send_to_server(char *, ...);  /* send to server. slow and easy */
void send_fast_to_server(char *, ...);  /* send to server. (more important messages) */
void  send_now_to_server(char *, ...);  /* send to server without checking for flooding */

int sendnextmessage();  /* Checks if a buffered message can be sent (Call this function every second or more often) 
			 * and sends the next message if that is the case
			 */
int server_has_queue();


#endif
