
/*********************************************************/
/**                                                     **/
/**      userlist.h (c) 1996, 97 Emiel Bruijntjes       **/
/**                                                     **/
/**          List of nicks I have seen on IRC           **/
/**                                                     **/
/*********************************************************/


#ifndef USERLIST_H_
#define USERLIST_H_

#include <time.h>
#include <stdio.h>

void save_userlist(FILE *);
int  load_userlist(FILE *, int);

int  userlist_maxlength();
void userlist_setmaxlength(int);
int  userlist_length();
int  userlist_kept();

void deleteuserlist();
void createunode(char *nick);
void deleteunode();
int userlist_findfirst();
int userlist_findnext();
int userlist_findnick(char *nick);
 
void userlist_incjoins();
void userlist_incleaves();
void userlist_incnicks();
void userlist_inckicks();
void userlist_inckickeds();
void userlist_incquits();
void userlist_incpublics();
void userlist_incmodes();
void userlist_incontime();
void userlist_setlasthost(char *nickuserhost);
void userlist_setpassword(char *password);
int  userlist_setkeepentry();
void userlist_resetkeepentry();
void userlist_setmanipulation(int);

int userlist_protection();
int userlist_publics();
int userlist_kicks();
int userlist_kickeds();
int userlist_joins();
int userlist_leaves();
int userlist_quits();
int userlist_nicks();
int userlist_modes();
int userlist_ontime();
int userlist_manipulation();
char * userlist_nick();
char * userlist_lasthost();
char * userlist_password();
char userlist_keepentry();
time_t userlist_lastseen();
int userlist_msgpminute();
int userlist_msgphour();

int protection_publicfactor();
int protection_kickfactor();
int protection_kickedfactor();
int protection_joinfactor();
int protection_leavefactor();
int protection_nickfactor();
int protection_quitfactor();
int protection_ontimefactor();
int protection_modefactor();
int protection_manipfactor();

void protection_set_publicfactor(int);
void protection_set_kickfactor(int);
void protection_set_kickedfactor(int);
void protection_set_joinfactor(int);
void protection_set_leavefactor(int);
void protection_set_nickfactor(int);
void protection_set_quitfactor(int);
void protection_set_ontimefactor(int);
void protection_set_modefactor(int);
void protection_set_manipfactor(int);

#endif
