
/*******************************************************/
/**                                                   **/
/**       values.c (c) 1996, 97 Emiel Bruijntjes      **/
/**                                                   **/
/**                "Global" variables.                **/
/**                                                   **/
/*******************************************************/

#include <stdlib.h>


#include "values.h"
#include "misc.h"
#include "net.h"
#include "config.h"
#include "console.h"


int      default_outside_partyline=0;         /* Partyline joined when someone makes telnet connection */
int      default_irc_partyline=0;             /* Partyline joined with session-command !party */
char     botnick[10]="EemBot";                /* The nick of the bot */
char    *login=NULL;                          /* Login of the bot. Works bettet when you do not have identd */
char    *ircname=NULL;                        /* IRC-name of realname of the bot */
char    *maintainer=NULL;                     /* The maintainer of the bot */
char     current_nick[10];                    /* The nick the bot currently has on IRC */
int      maxcycles=5;                         /* How many times should we cycle through the server-list before crashing? */
int      maxdccgetfilesize=500000;            /* Maximum filesize the bot will accept */
time_t   starttime=0;                         /* The time the bot was started */
char     *httpdir=NULL;                       /* The root-directory of the http-server */
unsigned int internetbytessent=0;             /* The number of bytes sent over the internet */
unsigned int internetbytesreceived=0;         /* Number of bytes received over the internet */
char    *notefile=NULL;                       /* The file where the notes are stored */
char     commandchar1='!';                    /* IRC command-char */
char     commandchar2='.';                    /* Partyline command-char */
char     commandchar3='/';                    /* Console command-char */
char    *su_password=NULL;                    /* Password of the superuser */
char    *helpdir=NULL;                        /* Help-files-directory */
char    *whoisdir=NULL;                       /* Whois-files-directory */
int      listensockptr=-1;                    /* The pointer to the telnet-port */
int      httpsockptr=-1;                      /* The pointer to the http-server */
int      httpport=8080;                       /* The portnumber of the http-port */
int      listenport=3333;                     /* The portnumber of the listen-port */
char    *ftp_root_dir=NULL;                   /* The root-directory of the file */
char    *wordfile=NULL;                       /* The wordfile for hangman */
char    *incoming_dir=NULL;                   /* Directory where DCC GET files are stored */
int      warnings=0;                          /* Number of warnings the bot should send before kicking */
int      dcc_block_size=512;                  /* DCC block size */
char    *irc_logfile=NULL;                    /* logfile where IRC messages are stored */
char    *http_logfile=NULL;                   /* logfile where HTTP messages are stored */
char    *session_logfile=NULL;                /* logfile where session messages are stored */
char    *party_logfile=NULL;                  /* logfile where messages from outside connections are stored */
int      maxnotefilesize=200000;              /* Maximum size of notefile */
time_t   notetimeout=100000;                  /* Number of seconds a note should be stored */
char    *progname;                            /* The name the command was started by */
char    *motd_file;                           /* Message of the day */
char    *xfont=NULL;                          /* Font used for the xwindows */
int      flood=6;                             /* Maximum number of messages per 10 seconds that are allowed */

void init_values() {

  login = (char *)xmalloc(strlen("unknown")+1);
  ircname = (char *)xmalloc(strlen(VERSION)+1);
  maintainer = (char *)xmalloc(strlen("Maintainer not known")+1);
  httpdir = (char *)xmalloc(strlen("../http/")+1);
  notefile = (char *)xmalloc(strlen("notefile")+1);
  su_password = (char *)xmalloc(strlen("password")+1);
  helpdir = (char *)xmalloc(strlen("../help/")+1);
  whoisdir = (char *)xmalloc(strlen("../whois/")+1);
  ftp_root_dir = (char *)xmalloc(strlen("../files/")+1);
  wordfile = (char *)xmalloc(strlen("/usr/dict/words")+1);
  incoming_dir = (char *)xmalloc(strlen("../files/")+1);
  irc_logfile = (char *)xmalloc(strlen("/dev/null")+1);
  http_logfile = (char *)xmalloc(strlen("/dev/null")+1);
  session_logfile = (char *)xmalloc(strlen("/dev/null")+1);
  party_logfile = (char *)xmalloc(strlen("/dev/null")+1);
  motd_file = (char *)xmalloc(strlen("motd")+1);
  xfont = (char *)xmalloc(strlen("-*-fixed-medium-*-*-*-14-*-*-*-*-*-*-*")+1);
  strcpy(login, "unknown");
  strcpy(ircname, VERSION);
  strcpy(maintainer, "Maintainer not known");
  strcpy(httpdir, "../http/");
  strcpy(notefile, "notefile");
  strcpy(su_password, "password");
  strcpy(helpdir, "../help/");
  strcpy(whoisdir, "../whois/");
  strcpy(ftp_root_dir, "../files/");
  strcpy(wordfile, "/usr/dict/words");
  strcpy(incoming_dir, "../files/");
  strcpy(irc_logfile, "/dev/null");
  strcpy(http_logfile, "/dev/null");
  strcpy(session_logfile, "/dev/null");
  strcpy(party_logfile, "/dev/null");
  strcpy(motd_file, "motd");
  strcpy(xfont, "-*-fixed-medium-*-*-*-14-*-*-*-*-*-*-*");
}


void save_values(FILE *fp) {

  fwriteint(fp, default_outside_partyline);
  fwritestr2bin(login, fp);
  fwritestr2bin(ircname, fp);
  fwritestr2bin(maintainer, fp);
  fwritestr2bin(httpdir, fp);
  fwritestr2bin(notefile, fp);
  fwriteint(fp, maxcycles);
  fwriteint(fp, maxdccgetfilesize);
  fwritechar(fp, commandchar1);
  fwritechar(fp, commandchar2);
  fwritechar(fp, commandchar3);
  fwritestr2bin(su_password, fp);
  fwritestr2bin(helpdir, fp);
  fwritestr2bin(whoisdir, fp);
  fwriteint(fp, listenport);
  fwriteint(fp, httpport);
  fwritestr2bin(ftp_root_dir, fp);
  fwritestr2bin(wordfile, fp);
  fwritestr2bin(incoming_dir, fp);
  fwriteint(fp, warnings);
  fwriteint(fp, dcc_block_size);
  fwritestr2bin(irc_logfile, fp);
  fwritestr2bin(http_logfile, fp);
  fwritestr2bin(session_logfile, fp);
  fwritestr2bin(party_logfile, fp);
  fwriteint(fp, maxnotefilesize);
  fwriteint(fp, notetimeout);
  fwritestr2bin(motd_file, fp);
  fwritestr2bin(xfont, fp);
  fwriteint(fp, flood);
  fwriteint(fp, 56129);
}

int  load_values(FILE *fp, int version) {

  int tmp;

  freadint(fp, &default_outside_partyline);
  fgetstrfrombin(&login, fp);
  fgetstrfrombin(&ircname, fp);
  fgetstrfrombin(&maintainer, fp);
  fgetstrfrombin(&httpdir, fp);
  fgetstrfrombin(&notefile, fp);
  freadint(fp, &maxcycles);
  freadint(fp, &maxdccgetfilesize);
  freadchar(fp, &commandchar1);
  freadchar(fp, &commandchar2);
  freadchar(fp, &commandchar3);
  fgetstrfrombin(&su_password, fp);
  fgetstrfrombin(&helpdir, fp);
  fgetstrfrombin(&whoisdir, fp);
  freadint(fp, &listenport);
  if (give_localport(listensockptr) != listenport) {
    close_socketptr(listensockptr);
    listensockptr = start_listen(T_ANNON, listenport);
  }
  freadint(fp, &httpport);
  if (give_localport(httpsockptr) != httpport) {
    close_socketptr(httpsockptr);
    httpsockptr = start_listen(T_HTTP, httpport);
  }
  fgetstrfrombin(&ftp_root_dir, fp);
  fgetstrfrombin(&wordfile, fp);
  fgetstrfrombin(&incoming_dir, fp);
  freadint(fp, &warnings);
  freadint(fp, &dcc_block_size);
  fgetstrfrombin(&irc_logfile, fp);
  fgetstrfrombin(&http_logfile, fp);
  fgetstrfrombin(&session_logfile, fp);
  fgetstrfrombin(&party_logfile, fp);
  if (version < 37) {
    freadint(fp, &tmp);
  }
  if (version >= 31) {
    freadint(fp, &maxnotefilesize);
    freadtime_t(fp, &notetimeout);
  }
  if (version >= 35) {
    fgetstrfrombin(&motd_file, fp);
  }
  if (version >= 42) {
    fgetstrfrombin(&xfont, fp);
  }
  if (version >= 43) {
    freadint(fp, &flood);
  }
  freadint(fp, &tmp);
  return (tmp == 56129);
}

int  returndefaultoutsidepartyline() { return default_outside_partyline; }
void setdefaultoutsidepartyline(int newvalue) { 
  
  if ((newvalue < 0) || (newvalue > 99999)) return;
  default_outside_partyline = newvalue; 
}

char *returnlogin()        { return login; }
void  setbotlogin(char *n) { login = (char *)xrealloc(login, strlen(n) + 1); strcpy(login, n); }

char *returnircname()     { return ircname; }
void  setircname(char *n) { ircname = (char *)xrealloc(ircname, strlen(n) + 1); strcpy(ircname, n); }

int  returncycles()     { return maxcycles; }
void setcycles(int val) { maxcycles = val; }

int  returnmaxdccgetfilesize()          { return maxdccgetfilesize; }
void setmaxdccgetfilesize(int newvalue) { maxdccgetfilesize = newvalue; }

char *returnhttpdir() { return httpdir; }
void  sethttpdir(char *dir) {

  if (dir[strlen(dir)-1] == '/') {
    httpdir = (char *)xrealloc(httpdir, strlen(dir)+1);
    strcpy(httpdir, dir);
  }
  else {
    httpdir = (char *)xrealloc(httpdir, strlen(dir)+2);
    sprintf(httpdir, "%s/", dir);
  }
}

char *returnnotefile() { return notefile; }
void  setnotefile(char *file) {

  if (file[strlen(file)-1]=='/') return;

  notefile = (char *) xrealloc (notefile, strlen(file) + 1);
  strcpy(notefile, file);
}

void  setcommandchar1(char *str) { commandchar1 = str[0]; }
char *returncommandchar1() {

  static char str[2];

  str[0] = commandchar1;
  str[1] = '\0';
  return str;
}

void  setcommandchar2(char *str) { commandchar2 = str[0]; }
char *returncommandchar2() {

  static char str[2];

  str[0] = commandchar2;
  str[1] = '\0';
  return str;
}

void  setcommandchar3(char *str) { commandchar3 = str[0]; }
char *returncommandchar3() {

  static char str[2];

  str[0] = commandchar3;
  str[1] = '\0';
  return str;
}

int returndefaultircpartyline() { return default_irc_partyline; }
void setdefaultircpartyline(int value) { 

  if ((value < 0) || (value > 99999)) return;
  default_irc_partyline = value;
}

char *returnftp_root_dir() { return ftp_root_dir; }
void  setftp_root_dir(char *dir) {

  if (dir[strlen(dir)-1] == '/') {
    ftp_root_dir = (char *)xrealloc(ftp_root_dir, strlen(dir)+1);
    strcpy(ftp_root_dir, dir);
  }
  else {
    ftp_root_dir = (char *)xrealloc(ftp_root_dir, strlen(dir)+2);
    sprintf(ftp_root_dir, "%s/", dir);
  }
}

char *returnsu_password() { return su_password; }
void setsu_password(char *passwd) {

  su_password = (char *)xrealloc(su_password, strlen(passwd)+1);
  strcpy(su_password, passwd);
}

char *returnhelpdir() { return helpdir; }
void sethelpdir(char *dir) {

  if (dir[strlen(dir)-1] == '/') {
    helpdir = (char *)xrealloc(helpdir, strlen(dir)+1);
    strcpy(helpdir, dir);
  }
  else {
    helpdir = (char *)xrealloc(helpdir, strlen(dir)+2);
    sprintf(helpdir, "%s/", dir);
  }
}

char *returnwhoisdir() { return whoisdir; }
void setwhoisdir(char *dir) {

  if (dir[strlen(dir)-1] == '/') {
    whoisdir = (char *)xrealloc(whoisdir, strlen(dir)+1);
    strcpy(whoisdir, dir);
  }
  else {
    whoisdir = (char *)xrealloc(whoisdir, strlen(dir)+2);
    sprintf(whoisdir, "%s/", dir);
  }
}

char *returnmaintainer() { return maintainer; }
void setmaintainer(char *newvalue) {

  maintainer = (char *)xrealloc(maintainer, strlen(newvalue)+1);
  strcpy(maintainer, newvalue);
}

char *returnwordfile() { return wordfile; }
void  setwordfile(char *file) {

  if (file[strlen(file)-1]=='/') return;

  wordfile = (char *) xrealloc (wordfile, strlen(file) + 1);
  strcpy(wordfile, file);
}

int  returnwarnings() { return warnings; }
void setwarnings(int value) { if (value >= 0) warnings = value; }

int  returndcc_block_size() { return dcc_block_size; }
void setdcc_block_size(int value) { if (dcc_block_size <= WAYTOBIG) dcc_block_size = value; }

char *returnincoming_dir() { return incoming_dir; }
void  setincoming_dir(char *dir) {

  if (dir[strlen(dir)-1] == '/') {
    incoming_dir = (char *)xrealloc(incoming_dir, strlen(dir)+1);
    strcpy(incoming_dir, dir);
  }
  else {
    incoming_dir = (char *)xrealloc(incoming_dir, strlen(dir)+2);
    sprintf(incoming_dir, "%s/", dir);
  }
}

char *returnirc_logfile() { return irc_logfile; }
void  setirc_logfile(char *file) {

  if (file[strlen(file)-1]=='/') return;

  irc_logfile = (char *) xrealloc (irc_logfile, strlen(file) + 1);
  strcpy(irc_logfile, file);
}

char *returnhttp_logfile() { return http_logfile; }
void  sethttp_logfile(char *file) {

  if (file[strlen(file)-1]=='/') return;

  http_logfile = (char *) xrealloc (http_logfile, strlen(file) + 1);
  strcpy(http_logfile, file);
}

char *returnsession_logfile() { return session_logfile; }
void  setsession_logfile(char *file) {

  if (file[strlen(file)-1]=='/') return;

  session_logfile = (char *) xrealloc (session_logfile, strlen(file) + 1);
  strcpy(session_logfile, file);
}

char *returnparty_logfile() { return party_logfile; }
void  setparty_logfile(char *file) {

  if (file[strlen(file)-1]=='/') return;

  party_logfile = (char *) xrealloc (party_logfile, strlen(file) + 1);
  strcpy(party_logfile, file);
}

int  returnmaxnotefilesize() { return maxnotefilesize; }
void setmaxnotefilesize(int newvalue) { 
  
  if (newvalue < 0) return;
  maxnotefilesize = newvalue; 
}

int  returnnotetimeout() { return (int)notetimeout; }
void setnotetimeout(int newvalue) { 
  
  if (newvalue < 0) return;
  notetimeout = (time_t)newvalue; 
}

char *returnmotd_file() { return motd_file; }
void  setmotd_file(char *file) {

  if (file[strlen(file)-1]=='/') return;

  motd_file = (char *) xrealloc (motd_file, strlen(file) + 1);
  strcpy(motd_file, file);
}

char *returnxfont() { return xfont; }
void  setxfont(char *file) {

  if (file[strlen(file)-1]=='/') return;

  xfont = (char *) xrealloc (xfont, strlen(file) + 1);
  strcpy(xfont, file);
}

int  returnflood()     { return flood; }
void setflood(int val) { flood = val; }
